/* arslds.h
 *
 * Copyright (C) 2006 Bertrand Mesot
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA 02110-1301, USA.
 */

#ifndef ARSLDS_H
#define ARSLDS_H

#include <stdio.h>

#include "matrix.h"
#include "darray.h"

typedef struct arslds_t_ {
  int S, H, K, D;

  double *prior;
  double **stran;
  
  matrix **pMean;
  matrix **pCov;
  matrix **A;
  double *CovH;
  double *CovV;
  double *vbias;
} arslds_t;

void arslds_fwd_sgl(arslds_t *arslds, int T, double *v, 
		    double **gainH, double **gainV, double **gainN,
		    double **logr, darray *f, darray *F, double *llh);

void arslds_bwd_sgl(arslds_t *arslds, int T, 
		    double **gainH, double **gainN,
		    double **logr, darray *f, darray *F, double **logl, 
		    darray *pair_mean, darray *pair_2mom, int useKim);

void arslds_mix2sgl(int N, double *logp, double logz,
		    darray *means, darray *Covs,
		    matrix *mean, matrix *Cov);

#endif
