/* utils.c
 *
 * Copyright (C) 2006 Bertrand Mesot
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA 02110-1301, USA.
 */

#include <math.h>

#include "utils.h"
/*-------------------------------------------------------------------------*/
double logadd(double x1, double x2) {

  if (x1 == x2)
    return x1 + log(2);
  else
    if (x1 > x2)
      return x1 + log(1+exp(x2-x1));
    else
      return x2 + log(1+exp(x1-x2));
}
/*-------------------------------------------------------------------------*/
double logsum(int n, double *x) {
  int i;
  double s = x[0];

  for (i=1; i<n; ++i)
    s = logadd(s, x[i]);

  return s;
}
/*-------------------------------------------------------------------------*/
